/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

/**
 *
 * @author Lawal 
 */
public class Interval {
    enum Limit
    {
        LOWER,
        UPPER
    }
    
    public class Builder {
        public Builder setA(double a) {
            Interval.this.setA(a);
            return this;
        }

        public Builder setB(double b) {
            Interval.this.setB(b);
            return this;
        }
        
        public Builder setAB(double v) {
            Interval.this.setA(v);
            Interval.this.setB(v);
            return this;
        }

        public Interval build() {
            return Interval.this;
        }
    }

    double a;
    public double getA() {
        return a;
    }
    public void setA(double a) {
        this.a = a;
        
        c = (a + b) / 2.0;
    }

    double b;
    public  double getB() {
        return b;
    }
    public void setB(double b) {
        this.b = b;
        
        c = (a + b) / 2.0;
    }
    
    double c;
    public  double getC() {
        return c;
    }
    public void setC(double c) {
        this.c = c;
    }

    public Interval(double a, double b)
    {
        this.a = a;
        this.b = b;
        
        c = (a + b) / 2.0;
    }
    
    public Interval(double ab)
    {
        this.a = ab;
        this.b = ab;
        
        c = (a + b) / 2.0;
    }

    Interval()
    {
        this.a = 0;
        this.b = 0;
        
        c = (a + b) / 2.0;
    }
    
    public void setAB(double a, double b)
    {
        this.a = a;
        this.b = b;
        
        c = (a + b) / 2.0;
    }

    double getLimit(Limit limit) 
    {
        if(limit == Limit.LOWER)
        {
            return a;
        }
        else
        {
            return b;
        }
    }
    
    public double getCenter() {
        return (a + b) / 2;
    }
    
    public double getPreciseCenter() {
        return c;
    }

    void enlarge(Interval interval)
    {
        if(a > interval.getA())
        {
            a = interval.getA();
        }

        if(b < interval.getB())
        {
            b = interval.getB();
        }
    }
    
    boolean isOverlapped(Interval interval) {
        boolean overlapped = true;
        
        if(interval.getA() > b) {
            overlapped = false;
        }

        if(interval.getB() < a) {
            overlapped = false;
        }
    
        return overlapped;
    }
    
    boolean isDimCutBy(int dim, double cut) {
        return a < cut && cut < b;
    }

    public String toFullString() {
        if(a == b) {
            return "[" + Double.toString(a) +  "]";
        }
        else {
            return "[" + Double.toString(a) + ", " + Double.toString(b) + "]";
        }
    }
    
    Interval deepClone()
    {
        Interval clone = new Interval(a, b);
        return clone;
    }
}
