/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

/**
 *
 * @author Lawal
 */
class RAsteriskInsertDataAlgo {
    class Input {
        Node data;
        Node getData() {
            return data;
        }
        void setData(Node data) {
            this.data = data;
        }

        int reInsertCount;
        int getReInsertCount() {
            return reInsertCount;
        }
        void setReInsertCount(int reInsertCount) {
            this.reInsertCount = reInsertCount;
        }
    }
    
    class Output {
    }
    
    class Builder {
        Builder setData(Node data) {
            RAsteriskInsertDataAlgo.this.input.data = data;
            return this;
        }

        Builder setReInsertCount(int reInsertCount) {
            RAsteriskInsertDataAlgo.this.input.reInsertCount = reInsertCount;
            return this;
        }
        
        RAsteriskInsertDataAlgo build() {
            return RAsteriskInsertDataAlgo.this;
        }
    }

    Input input = new Input();
    Input getInput() {
        return input;
    }
    void setInput(Input input) {
        this.input = input;
    }
    
    Output output = new Output();
    Output getOutput() {
        return output;
    }
    void setOutput(Output output) {
        this.output = output;
    }
    
    RAsteriskInsertNodeAlgo insertNodeAlgo = new RAsteriskInsertNodeAlgo();
    RAsteriskInsertNodeAlgo getInsertNodeAlgo() {
        return insertNodeAlgo;
    }
    void setInsertNodeAlgo(RAsteriskInsertNodeAlgo insertNodeAlgoBase) {
        this.insertNodeAlgo = insertNodeAlgoBase;
    }

    Builder builder;
    public Builder getBuilder() {
        if(builder == null) {
            builder = new Builder();
        }
        return builder;
    }

    void execute(RTreeBase rTree) {
        if(rTree.getDebugMode() >= 1) {
            System.out.println("Insert Data Algo Input");
            System.out.println("Data:");
            rTree.deepPrint(input.data);
            System.out.println("ReInsertCount:");
            System.out.println(input.reInsertCount);
            System.out.println();
        }

        insertNodeAlgo.getOverflowTreatmentAlgo().getVisitedLevels().clear();
        
        insertNodeAlgo.getBuilder().
                        setNode(input.data).
                        setLevel(rTree.getLeafNodeLevel()).
                        setReInsertCount(input.reInsertCount).
                            build().
                                execute(rTree);
    }
}
