/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

/**
 *
 * @author Lawal
 */
class RAsteriskInsertNodeAlgo {
    class Input {
        Node node;
        Node getNode() {
            return node;
        }
        void setNode(Node node) {
            this.node = node;
        }
    
        int level;
        int getLevel() {
            return level;
        }
        void setLevel(int level) {
            this.level = level;
        }

        int reInsertCount;
        int getReInsertCount() {
            return reInsertCount;
        }
        void setReInsertCount(int reInsertCount) {
            this.reInsertCount = reInsertCount;
        }
    }
    
    class Output {
    }
    
    class Builder {
        Builder setNode(Node node) {
            RAsteriskInsertNodeAlgo.this.input.node = node;
            return this;
        }

        Builder setLevel(int level) {
            RAsteriskInsertNodeAlgo.this.input.level = level;
            return this;
        }

        Builder setReInsertCount(int reInsertCount) {
            RAsteriskInsertNodeAlgo.this.input.reInsertCount = reInsertCount;
            return this;
        }
        
        RAsteriskInsertNodeAlgo build() {
            return RAsteriskInsertNodeAlgo.this;
        }
    }
    
    Input input = new Input();
    Input getInput() {
        return input;
    }
    void setInput(Input input) {
        this.input = input;
    }
    
    Output output = new Output();
    Output getOutput() {
        return output;
    }
    void setOutput(Output output) {
        this.output = output;
    }

    RAsteriskChooseSubTreeAlgo chooseSubTreeAlgo = new RAsteriskChooseSubTreeAlgo();
    RAsteriskChooseSubTreeAlgo getChooseSubTreeAlgo() {
        return chooseSubTreeAlgo;
    }
    void setChooseSubTreeAlgo(RAsteriskChooseSubTreeAlgo chooseSubTreeAlgo) {
        this.chooseSubTreeAlgo = chooseSubTreeAlgo;
    }
    
    RAsteriskOverflowTreatmentAlgo overflowTreatmentAlgo = new RAsteriskOverflowTreatmentAlgo(this);
    RAsteriskOverflowTreatmentAlgo getOverflowTreatmentAlgo() {
        return overflowTreatmentAlgo;
    }
    void setOverflowTreatmentAlgo(RAsteriskOverflowTreatmentAlgo overflowTreatmentAlgo) {
        this.overflowTreatmentAlgo = overflowTreatmentAlgo;
    }

    Builder builder;
    public Builder getBuilder() {
        if(builder == null) {
            builder = new Builder();
        }
        return builder;
    }

    void execute(RTreeBase rTree) {
        if(rTree.getDebugMode() >= 1) {
            System.out.println("Insert Node Algo Input");
            System.out.println("Node:");
            rTree.deepPrint(input.node);
            System.out.println("ReInsertCount:");
            System.out.println(input.reInsertCount);
            System.out.println("Level:");
            System.out.println(input.level);
            System.out.println();
        }

        chooseSubTreeAlgo.getBuilder().
                            setNode(rTree.rootNode).
                            setEntry(input.node).
                            setLevel(input.level).
                                build().
                                    execute(rTree);
                
        chooseSubTreeAlgo.getOutput().getNode().getBuilder().addEntry(input.node);
        
        if(chooseSubTreeAlgo.getOutput().getNode().ExceedMaxEntries()) {
            overflowTreatmentAlgo.getBuilder().
                                    setNode(chooseSubTreeAlgo.getOutput().getNode()).
                                    setLevel(input.level).
                                    setReInsertCount(input.reInsertCount).
                                        build().
                                            execute(rTree);
        }
    }
}
