/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

/**
 *
 * @author Lawal
 */
class RAsteriskSplitNodeAlgo {
    class Input {
        Node node;
         Node getNode() {
            return node;
        }
         void setNode(Node node) {
            this.node = node;
        }
    }
    
    static class Output {
        Node node1;
         void setNode1(Node node1) {
            this.node1 = node1;
        }
         Node getNode1() {
            return node1;
        }

        Node node2;
         Node getNode2() {
            return node2;
        }
         void setNode2(Node node2) {
            this.node2 = node2;
        }
    }
    
    class Builder {
        Builder setNode(Node node) {
            RAsteriskSplitNodeAlgo.this.input.node = node;
            return this;
        }

        RAsteriskSplitNodeAlgo build() {
            return RAsteriskSplitNodeAlgo.this;
        }
    }
    
    Input input = new Input();
    Input getInput() {
        return input;
    }
    void setInput(Input input) {
        this.input = input;
    }
    
    Output output = new Output();
    Output getOutput() {
        return output;
    }
    void setOutput(Output output) {
        this.output = output;
    }
    
    RAsteriskChooseSplitAxisAlgo chooseSplitAxisAlgo = new RAsteriskChooseSplitAxisAlgo();
    RAsteriskChooseSplitAxisAlgo getChooseSplitAxisAlgo() {
        return chooseSplitAxisAlgo;
    }
    void setChooseSplitAxisAlgo(RAsteriskChooseSplitAxisAlgo chooseSplitAxisAlgo) {
        this.chooseSplitAxisAlgo = chooseSplitAxisAlgo;
    }
    
    RAsteriskChooseSplitIndexAlgo chooseSplitIndexAlgo = new RAsteriskChooseSplitIndexAlgo();
    RAsteriskChooseSplitIndexAlgo getChooseSplitIndexAlgo() {
        return chooseSplitIndexAlgo;
    }
    void setChooseSplitIndexAlgo(RAsteriskChooseSplitIndexAlgo chooseSplitIndexAlgo) {
        this.chooseSplitIndexAlgo = chooseSplitIndexAlgo;
    }

    Builder builder;
    public Builder getBuilder() {
        if(builder == null) {
            builder = new Builder();
        }
        return builder;
    }

    void execute(RTreeBase rTree) {
        if(rTree.getDebugMode() >= 1) {
            System.out.println("Split Node Algo Input");
            System.out.println("Node:");
            rTree.deepPrint(input.node);
            System.out.println();
        }

        chooseSplitAxisAlgo.getBuilder().
                                setNode(input.node).
                                    build().
                                        execute(rTree);
        
        chooseSplitIndexAlgo.getBuilder().
                                setNode(input.node).
                                setAxis(chooseSplitAxisAlgo.getOutput().getAxis()).
                                    build().
                                        execute(rTree);
        
        output.node1 = chooseSplitIndexAlgo.getOutput().getNode1(); 
        output.node2 = chooseSplitIndexAlgo.getOutput().getNode2(); 

        if(rTree.getDebugMode() >= 1) {
            System.out.println("Split Node Algo Output");
            System.out.println("Node1:");
            rTree.deepPrint(output.node1);
            System.out.println("Node2:");
            rTree.deepPrint(output.node2);
            System.out.println();
        }
    }
}
