/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

import java.util.ArrayList;

/**
 *
 * @author Lawal
 */
class RPlusAdjustTreeAlgo {
    class Input {
        Node node;
        Node getNode() {
            return node;
        }
        void setNode(Node node) {
            this.node = node;
        }
    }
    
    static class Output {
    }
    
    class Builder {
        Builder setNode(Node node) {
            RPlusAdjustTreeAlgo.this.input.node = node;
            return this;
        }

        RPlusAdjustTreeAlgo build() {
            return RPlusAdjustTreeAlgo.this;
        }
    }

    Input input = new Input();
    Input getInput() {
        return input;
    }
    void setInput(Input input) {
        this.input = input;
    }
    
    Output output = new Output();
    Output getOutput() {
        return output;
    }
    void setOutput(Output output) {
        this.output = output;
    }

    Builder builder;
    public Builder getBuilder() {
        if(builder == null) {
            builder = new Builder();
        }
        return builder;
    }

    void execute(RTreeBase rTree) {
        if(rTree.getDebugMode() >= 1) {
            System.out.println("RPlus Adjust Tree Algo Input");
            System.out.println("Node:");
            rTree.deepPrint(input.node);
            System.out.println();
        }
        
        for(Node entry: new ArrayList<>(input.node.getEntries())) {
            if(entry.isOverlapped(input.node)) {
                entry.PackInside(input.node);
                    
                new RPlusAdjustTreeAlgo().getBuilder().setNode(entry).build().execute(rTree);
            }
            else {
                input.node.getBuilder().removeEntryNoUpdate(entry);
            }
        }
    }
}
