/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

/**
 *
 * @author Lawal
 */
class RPlusInsertDataAlgo {
    class Input {
        Node data;
        Node getData() {
            return data;
        }
        void setData(Node data) {
            this.data = data;
        }

        Node insertSubTree;
        Node getInsertSubTree() {
            return insertSubTree;
        }
        void setInsertSubTree(Node insertSubTree) {
            this.insertSubTree = insertSubTree;
        }

        int fillFactor;
        int getFillFactor() {
            return fillFactor;
        }
        void setFillFactor(int fillFactor) {
            this.fillFactor = fillFactor;
        }
    }
    
    static class Output {
    }
    
    Input input = new Input();
    Input getInput() {
        return input;
    }
    void setInput(Input input) {
        this.input = input;
    }
    
    Output output = new Output();
    Output getOutput() {
        return output;
    }
    void setOutput(Output output) {
        this.output = output;
    }
    
    class Builder {
        Builder setData(Node data) {
            RPlusInsertDataAlgo.this.input.data = data;
            return this;
        }

        Builder setInsertSubTree(Node insertSubTree) {
            RPlusInsertDataAlgo.this.input.insertSubTree = insertSubTree;
            return this;
        }
        
        Builder setFillFactor(int fillFactor) {
            RPlusInsertDataAlgo.this.input.fillFactor = fillFactor;
            return this;
        }

        RPlusInsertDataAlgo build() {
            return RPlusInsertDataAlgo.this;
        }
    }

    RTreeInsertDataAlgo insertDataAlgo = new RTreeInsertDataAlgo();
    RTreeInsertDataAlgo getInsertDataAlgo() {
        return insertDataAlgo;
    }
    void setInsertDataAlgo(RTreeInsertDataAlgo insertDataAlgo) {
        this.insertDataAlgo = insertDataAlgo;
    }
    
    RPlusSplitNodeAlog splitNodeAlog = new RPlusSplitNodeAlog();
    RPlusSplitNodeAlog getSplitAlog() {
        return splitNodeAlog;
    }
    void setSplitAlog(RPlusSplitNodeAlog splitAlog) {
        this.splitNodeAlog = splitAlog;
    }

    Builder builder;
    public Builder getBuilder() {
        if(builder == null) {
            builder = new Builder();
        }
        return builder;
    }

    void execute(RTreeBase rTree) {
        if(rTree.getDebugMode() >= 1) {
            System.out.println("RPlus Insert Data Algo Input");
            System.out.println("Data:");
            rTree.deepPrint(input.data);
            System.out.println("InsertSubTree:");
            rTree.deepPrint(input.insertSubTree);
            System.out.println("FillFactor:");
            System.out.println(Integer.toString(input.fillFactor));
            System.out.println();
        }

        if(input.insertSubTree.isLeafNode()) {
            input.insertSubTree.getBuilder().addEntry(input.data);
            
            if(input.insertSubTree.ExceedMaxEntries()) {
                splitNodeAlog.getBuilder().
                                setNode(input.insertSubTree).
                                setFillFactor(input.fillFactor).
                                    build().
                                        execute(rTree);
            }
        }
        else {
            boolean checkIfOverlapExists = false;
            
            for(Node entry: input.insertSubTree.getEntries().toArray(new Node[input.insertSubTree.getEntries().size()])) {
                if(entry.isOverlapped(input.data)) {
                    new RPlusInsertDataAlgo().getBuilder().
                                                setData(input.data.deepClone()).
                                                setInsertSubTree(entry).
                                                setFillFactor(input.fillFactor).
                                                    build().
                                                        execute(rTree);
                    
                    checkIfOverlapExists = true;
                }
            }
            
            if(!checkIfOverlapExists)
            {
                    insertDataAlgo.getBuilder().
                                    setData(input.data).
                                        build().
                                            execute(rTree);
            }
        }
    }
}
