/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

/**
 *
 * @author Lawal
 */
class RPlusSplitNodeAlog {
    class Input {
        Node node;
         Node getNode() {
            return node;
        }
         void setNode(Node node) {
            this.node = node;
        }

        int fillFactor;
        int getFillFactor() {
            return fillFactor;
        }
        void setFillFactor(int fillFactor) {
            this.fillFactor = fillFactor;
        }
    }
    
    class Output {
    }
    
    Input input = new Input();
    Input getInput() {
        return input;
    }
    void setInput(Input input) {
        this.input = input;
    }
    
    Output output = new Output();
    Output getOutput() {
        return output;
    }
    void setOutput(Output output) {
        this.output = output;
    }
    
    class Builder {
        Builder setNode(Node node) {
            RPlusSplitNodeAlog.this.input.node = node;
            return this;
        }

        Builder setFillFactor(int fillFactor) {
            RPlusSplitNodeAlog.this.input.fillFactor = fillFactor;
            return this;
        }

        RPlusSplitNodeAlog build() {
            return RPlusSplitNodeAlog.this;
        }
    }
    
    RPlusPartitionAlgo  partitionAlgo = new RPlusPartitionAlgo();
    RPlusPartitionAlgo getPartitionAlgo() {
        return partitionAlgo;
    }
    void setPartitionAlgo(RPlusPartitionAlgo partitionAlgo) {
        this.partitionAlgo = partitionAlgo;
    }
    
    RPlusAdjustTreeAlgo adjustTreeAlgo = new RPlusAdjustTreeAlgo();
    RPlusAdjustTreeAlgo getAdjustTreeAlgo() {
        return adjustTreeAlgo;
    }
    void setAdjustTreeAlgo(RPlusAdjustTreeAlgo adjustTreeAlgo) {
        this.adjustTreeAlgo = adjustTreeAlgo;
    }
    
    Builder builder;
    public Builder getBuilder() {
        if(builder == null) {
            builder = new Builder();
        }
        return builder;
    }
    
    void execute(RTreeBase rTree) {
        if(rTree.getDebugMode() >= 1) {
            System.out.println("RPlus Split Algo Input");
            System.out.println("Node:");
            rTree.deepPrint(input.node);
            System.out.println("Dim:");
            System.out.println();
        }

        partitionAlgo.getBuilder().
                        setNode(input.node).
                        setFillFactor(input.fillFactor).
                            build().
                                execute(rTree);
        
        if(input.node.isRoot()) {
            rTree.createNewRootNode();
        }

        Node parent = input.node.getParent();
        
        for(Node onBorderEntry:partitionAlgo.getOutput().getOnBorderEntries()) {
            partitionAlgo.getOutput().getNode1().getBuilder().addEntry(onBorderEntry.deepClone());
        }
        partitionAlgo.getOutput().getNode1().pocessEntries();
        partitionAlgo.getOutput().getNode1().setIntervalB(partitionAlgo.getOutput().getDim(), partitionAlgo.getOutput().getDimCut());
        adjustTreeAlgo.getBuilder().setNode(partitionAlgo.getOutput().getNode1()).build().execute(rTree);
        parent.getBuilder().addEntry(partitionAlgo.getOutput().getNode1());
        
        partitionAlgo.getOutput().getNode2().pocessEntries();
        partitionAlgo.getOutput().getNode2().setIntervalA(partitionAlgo.getOutput().getDim(), partitionAlgo.getOutput().getDimCut());
        adjustTreeAlgo.getBuilder().setNode(partitionAlgo.getOutput().getNode2()).build().execute(rTree);
        parent.getBuilder().addEntry(partitionAlgo.getOutput().getNode2());
        
        parent.getBuilder().removeEntry(input.node);

        if(parent.ExceedMaxEntries()) {
            new RPlusSplitNodeAlog().getBuilder().
                                        setNode(parent).
                                        setFillFactor(input.fillFactor).
                                            build().
                                                execute(rTree);
        }
    }
}
