/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

import java.io.IOException;
import java.io.RandomAccessFile;

/**
 *
 * @author Lawal
 */
public class RTree extends RTreeBase {
    int dim;
    int getDim() {
        return dim;
    }
     void setDim(int dim) {
        this.dim = dim;
    }

    int minEntries;
     int getMinEntries() {
        return minEntries;
    }
     void setMinEntries(int minEntries) {
        this.minEntries = minEntries;
    }

    int maxEntries;
     int getMaxEntries() {
        return maxEntries;
    }
     void setMaxEntries(int maxEntries) {
        this.maxEntries = maxEntries;
    }

    RTreeInsertDataAlgo insertDataAlgo = new RTreeInsertDataAlgo();
    RTreeInsertDataAlgo getInsertDataAlgo() {
        return insertDataAlgo;
    }
    void setInsertDataAlgo(RTreeInsertDataAlgo insertDataAlgo) {
        this.insertDataAlgo = insertDataAlgo;
    }
    
    public RTree(RandomAccessFile file, int dim, int minEntries, int maxEntries) throws IOException {
        this.setFile(file);
        
        this.dim = dim;
        this.minEntries = minEntries;
        this.maxEntries = maxEntries;
        
        createNewRootNode();
    }

    @Override
    void createNewRootNode() {
        Node newRootNode = new Node().getBuilder()
                                .setDim(dim)
                                .setMinEntries(minEntries)
                                .setMaxEntries(maxEntries)
                                .setId("Root")
                                .setDebugMode(debugMode)
                                .setFile(file)
                                .setIsLoaded(true)
                                .build();

        if(rootNode != null) { 
            rootNode.getBuilder().setId(null);
            newRootNode.getBuilder().addEntry(rootNode);
        }
        
        rootNode = newRootNode;
    }

    @Override
    Node createIntermediateNode() {
        return new Node().getBuilder()
                        .setDim(dim)
                        .setMinEntries(minEntries)
                        .setMaxEntries(maxEntries)
                        .setDebugMode(debugMode)
                        .setFile(file)
                        .setIsLoaded(true)
                        .build();
    }

    @Override
    public Node createDataNode() {
        return new Node().getBuilder()
                        .setDim(dim)
                        .setMinEntries(minEntries)
                        .setMaxEntries(maxEntries)
                        .setIsData(true)
                        .setDebugMode(debugMode)
                        .setFile(file)
                        .setIsLoaded(true)
                        .build();
    }

    @Override
    public void InsertData(Node data) {
        insertDataAlgo.getBuilder().
                        setData(data).
                            build().
                                execute(this);
    }
}
