/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

/**
 *
 * @author Lawal
 */
class RTreeAdjustTreeAlgo {
    class Input {
        Node node;
        Node getNode() {
            return node;
        }
        void setNode(Node node) {
            this.node = node;
        }

        boolean isSplitted;
        boolean setIsSplitted() {
            return isSplitted;
        }
        void setIsSplitted(boolean isSplitted) {
            this.isSplitted = isSplitted;
        }
        
        Node node1;
        Node getNode1() {
            return node1;
        }
        void setNode1(Node node1) {
            this.node1 = node1;
        }

        Node node2;
        Node getNode2() {
            return node2;
        }
        void setNode2(Node node2) {
            this.node2 = node2;
        }
    }
    
    class Output {
    }
    
    class Builder {
        Node node;
        Builder setNode(Node node) {
            RTreeAdjustTreeAlgo.this.input.node = node;
            return this;
        }

        boolean isSplitted;
        Builder setIsSplitted(boolean isSplitted) {
            RTreeAdjustTreeAlgo.this.input.isSplitted = isSplitted;
            return this;
        }

        Node node1;
        Builder setNode1(Node node1) {
            RTreeAdjustTreeAlgo.this.input.node1 = node1;
            return this;
        }

        Node node2;
        Builder setNode2(Node node2) {
            RTreeAdjustTreeAlgo.this.input.node2 = node2;
            return this;
        }
        
        RTreeAdjustTreeAlgo build() {
            return RTreeAdjustTreeAlgo.this;
        }
    }
    
    Input input = new Input();
    Input getInput() {
        return input;
    }
    void setInput(Input input) {
        this.input = input;
    }
    
    Output output = new Output();
    Output getOutput() {
        return output;
    }
    void setOutput(Output output) {
        this.output = output;
    }

    RTreeQuadraticSplitNodeAlgo splitNodeAlgo = new RTreeQuadraticSplitNodeAlgo ();
    RTreeQuadraticSplitNodeAlgo getSplitNodeAlgo() {
        return splitNodeAlgo;
    }
    void setSplitNodeAlgo(RTreeQuadraticSplitNodeAlgo splitNode) {
        this.splitNodeAlgo = splitNode;
    }

    Builder builder;
    public Builder getBuilder() {
        if(builder == null) {
            builder = new Builder();
        }
        return builder;
    }

    void execute(RTreeBase rTree) {
        if(rTree.getDebugMode() >= 1) {
            System.out.println("Adjust Tree Algo Input");
            System.out.println("Node:");
            rTree.deepPrint(input.node);
            System.out.println("IsSplitted:");
            System.out.println(Boolean.toString(input.isSplitted));
            if(input.isSplitted) {
                System.out.println("Node1:");
                rTree.deepPrint(input.node1);
                System.out.println("Node2:");
                rTree.deepPrint(input.node2);
            }
            System.out.println();
        }

        if(input.isSplitted)
        {
            if(input.node.isRoot()) {
                rTree.createNewRootNode();
            }
            
            Node parent = input.node.getParent();
            
            input.node1.pocessEntries();
            parent.getBuilder().addEntry(input.node1).build();

            input.node2.pocessEntries();
            parent.getBuilder().addEntry(input.node2).build();
            
            parent.getBuilder().removeEntry(input.node).build();
            
            if(parent.ExceedMaxEntries())
            {
                splitNodeAlgo.getBuilder().
                                setNode(parent).
                                    build().
                                        execute(rTree);

                new RTreeAdjustTreeAlgo().getBuilder().
                                            setNode(parent).
                                            setIsSplitted(true).
                                            setNode1(splitNodeAlgo.getOutput().getNode1()).
                                            setNode2(splitNodeAlgo.getOutput().getNode2()).
                                                build().
                                                    execute(rTree);
            } 
        }
        else
        {
            if(!input.node.isRoot()) {
                new RTreeAdjustTreeAlgo().getBuilder().
                                            setNode(input.node.getParent()).
                                            setIsSplitted(false).
                                            setNode1(null).
                                            setNode2(null).
                                                build().
                                                    execute(rTree);
            }
        }
    }
}
