/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

import java.util.ArrayList;
import java.util.List;
import spatial.tree.lab.utility.Rankable;

/**
 *
 * @author Lawal
 */
class RTreeChooseSubTreeAlgo {
    class Input {
        Node node;
        Node getNode() {
            return node;
        }
        void setNode(Node node) {
            this.node = node;
        }

        Node entry;
        Node getEntry() {
            return entry;
        }
        void setEntry(Node entry) {
            this.entry = entry;
        }
    }

    static class Output {
        Node node;
        Node getNode() {
            return node;
        }
        void setNode(Node node) {
            this.node = node;
        }

        class Builder {
            Builder setNode(Node node) {
                Output.this.node = node;
                return this;
            }

            Output build() {
                return Output.this;
            }
        }
    }
    
    class Builder {
        Builder setNode(Node node) {
            RTreeChooseSubTreeAlgo.this.input.node = node;
            return this;
        }

        Builder setEntry(Node entry) {
            RTreeChooseSubTreeAlgo.this.input.entry = entry;
            return this;
        }
        
        Builder execute(RTreeBase rTree) {
            RTreeChooseSubTreeAlgo.this.execute(rTree);
            return this;
        }

        RTreeChooseSubTreeAlgo build() {
            return RTreeChooseSubTreeAlgo.this;
        }
    }
    
    Input input = new Input();
    Input getInput() {
        return input;
    }
    void setInput(Input input) {
        this.input = input;
    }
    
    Output output = new Output();
    Output getOutput() {
        return output;
    }
    void setOutput(Output output) {
        this.output = output;
    }

    Builder builder;
    public Builder getBuilder() {
        if(builder == null) {
            builder = new Builder();
        }
        return builder;
    }

    void execute(RTreeBase rTree) {
        if(rTree.getDebugMode() >= 1) {
            System.out.println("Choose Sub Tree Algo Input");
            System.out.println("Node:");
            rTree.deepPrint(input.node);
            System.out.println("Entry:");
            rTree.deepPrint(input.entry);
            System.out.println();
        }

        Node node = input.node;
        
        if(node.isLeafNode())
        {
            output.node = node;
        }
        else
        {
            List<Rankable> nodes = new ArrayList<>();
            
            for(Node entry:node.getEntries()) {
                ((Rankable)entry).getSortRank().add(entry.getEnlargement(input.entry));
                ((Rankable)entry).getSortRank().add(entry.getArea());
                
                nodes.add(entry);
            }
            
            Rankable.sortAsendingAsending(nodes);
            
            output.node = (Node)nodes.get(0);
        
            output = new RTreeChooseSubTreeAlgo().getBuilder().
                                                    setEntry(input.entry).
                                                    setNode(output.node).
                                                    execute(rTree).
                                                        build().
                                                            output;
        }
        
        if(rTree.getDebugMode() >= 1) {
            System.out.println("Choose Sub Tree Algo Output");
            System.out.println("Node:");
            rTree.deepPrint(output.node);
            System.out.println();
        }
    }    
}
