/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

/**
 *
 * @author Lawal 
 */
class RTreeDistributeEntryAlgo {
    class Input {
        Node node1;
        Node getNode1() {
            return node1;
        }
        void setNode1(Node node1) {
            this.node1 = node1;
        }

        Node node2;
        Node getNode2() {
            return node2;
        }
        void setNode2(Node node2) {
            this.node2 = node2;
        }

        Node entry;
         Node getEntry() {
            return entry;
        }
         void setEntry(Node entry) {
            this.entry = entry;
        }
    }
    
    static class Output  {
    }

    class Builder {
        Builder setNode1(Node node1) {
            RTreeDistributeEntryAlgo.this.input.node1 = node1;
            return this;
        }

        Builder setNode2(Node node2) {
            RTreeDistributeEntryAlgo.this.input.node2 = node2;
            return this;
        }

        Builder setEntry(Node entry) {
            RTreeDistributeEntryAlgo.this.input.entry = entry;
            return this;
        }

        RTreeDistributeEntryAlgo build() {
           return RTreeDistributeEntryAlgo.this;
       } 
    }

    Input input = new Input();
    Input getInput() {
        return input;
    }
    void setInput(Input input) {
        this.input = input;
    }
    
    Output output = new Output();
    Output getOutput() {
        return output;
    }
    void setOutput(Output output) {
        this.output = output;
    }

    RTreePickNextAlgo pickNextAlgo = new RTreePickNextAlgo();
    RTreePickNextAlgo getPickNext() {
       return pickNextAlgo;
    }
    void setPickNext(RTreePickNextAlgo pickNext) {
       this.pickNextAlgo = pickNext;
    }

    Builder builder;
    public Builder getBuilder() {
        if(builder == null) {
            builder = new Builder();
        }
        return builder;
    }

    public void execute(RTreeBase rTree) {
        if(rTree.getDebugMode() >= 1) {
            System.out.println("Distribute Entry Algo Input");
            System.out.println("Node1:");
            rTree.deepPrint(input.node1);
            System.out.println("Node2:");
            rTree.deepPrint(input.node2);
            System.out.println("Entry:");
            rTree.deepPrint(input.entry);
            System.out.println();
        }

        pickNextAlgo.getBuilder().
                        seNode1(input.node1).
                        setNode2(input.node2).
                        setEntry(input.entry).
                            build().
                                execute(rTree);

        switch(pickNextAlgo.getOutput().getSelectedNode())
        {
            case 0:
                if(input.node1.getArea() < input.node2.getArea())
                {
                    input.node1.getBuilder().addEntryTemporary(input.entry).build();
                }

                if(input.node2.getArea() < input.node1.getArea())
                {
                    input.node2.getBuilder().addEntryTemporary(input.entry).build();
                }

                if(input.node1.getArea() == input.node2.getArea())
                {
                    if(input.node2.getEntries().size() > input.node1.getEntries().size())
                    {
                        input.node1.getBuilder().addEntryTemporary(input.entry).build();
                    }
                    else
                    {
                        input.node2.getBuilder().addEntryTemporary(input.entry).build();
                    }
                }
                break;

            case 1:
                input.node1.getBuilder().addEntryTemporary(input.entry).build();
                break;

            case 2:
                input.node2.getBuilder().addEntryTemporary(input.entry).build();
                break;
        }
    }
}
