/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

/**
 *
 * @author Lawal
 */
class RTreeInsertDataAlgo {
    class Input {
        Node data;
        Node getData() {
            return data;
        }
        void setData(Node data) {
            this.data = data;
        }
    }
    
    static class Output { 
    }
    
    class Builder {
        Builder setData(Node data) {
            RTreeInsertDataAlgo.this.input.data = data;
            return this;
        }

        RTreeInsertDataAlgo build() {
            return RTreeInsertDataAlgo.this;
        }
    }
    
    Input input = new Input();
    Input getInput() {
        return input;
    }
    void setInput(Input input) {
        this.input = input;
    }
    
    Output output = new Output();
    Output getOutput() {
        return output;
    }
    void setOutput(Output output) {
        this.output = output;
    }
    
    RTreeChooseSubTreeAlgo chooseLeafAlgo = new RTreeChooseSubTreeAlgo();
    RTreeChooseSubTreeAlgo getChooseLeafAlgo() {
        return chooseLeafAlgo;
    }
    void setChooseLeafAlgo(RTreeChooseSubTreeAlgo chooseLeafAlgo) {
        this.chooseLeafAlgo = chooseLeafAlgo;
    }

    RTreeQuadraticSplitNodeAlgo splitNodeAlgo = new RTreeQuadraticSplitNodeAlgo();
    RTreeQuadraticSplitNodeAlgo getSplitNodeAlgo() {
        return splitNodeAlgo;
    }
    void setSplitNodeAlgo(RTreeQuadraticSplitNodeAlgo splitNode) {
        this.splitNodeAlgo = splitNode;
    }

    RTreeAdjustTreeAlgo adjustTreeAlgo = new RTreeAdjustTreeAlgo();
    RTreeAdjustTreeAlgo getAdjustTreeAlgo() {
        return adjustTreeAlgo;
    }
    void setAdjustTreeAlgo(RTreeAdjustTreeAlgo adjustTreeAlgo) {
        this.adjustTreeAlgo = adjustTreeAlgo;
    }

    Builder builder;
    public Builder getBuilder() {
        if(builder == null) {
            builder = new Builder();
        }
        return builder;
    }

    void execute(RTreeBase rTree) {
        if(rTree.getDebugMode() >= 1) {
            System.out.println("Insert Data Algo Input");
            System.out.println("Data:");
            rTree.deepPrint(input.data);
            System.out.println();
        }

        Node leafNode = chooseLeafAlgo.getBuilder().
                                            setNode(rTree.getRootNode()).
                                            setEntry(input.getData()).
                                                execute(rTree).
                                                    build().
                                                        getOutput().
                                                            getNode();
        
        leafNode.getBuilder().addEntry(input.data);
        
        if(leafNode.ExceedMaxEntries())
        {
            splitNodeAlgo.getBuilder().
                                setNode(leafNode).
                                    build().
                                        execute(rTree);
                
            adjustTreeAlgo.getBuilder().
                                setNode(leafNode).
                                setIsSplitted(true).
                                setNode1(splitNodeAlgo.getOutput().getNode1()).
                                setNode2(splitNodeAlgo.getOutput().getNode2()).build().
                                                                    execute(rTree);
        }
        else
        {
            adjustTreeAlgo.getBuilder().
                            setNode(leafNode).
                            setIsSplitted(false).
                            setNode1(null).
                            setNode2(null).build().
                                            execute(rTree);
        }
    }
}
