/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

/**
 *
 * @author Lawal 
 */
 class RTreePickNextAlgo {
    class Input {
        Node node1;
         Node getNode1() {
            return node1;
        }
         void setNode1(Node node1) {
            this.node1 = node1;
        }

        Node node2;
         Node getNode2() {
            return node2;
        }
         void setNode2(Node node2) {
            this.node2 = node2;
        }

        Node entry;
         Node getEntry() {
            return entry;
        }
         void setEntry(Node entry) {
            this.entry = entry;
        }
    }

    static class Output {
        int selectedNode;
         int getSelectedNode() {
            return selectedNode;
        }
        void setSelectedNode(int selectedNode) {
            this.selectedNode = selectedNode;
        }
    }
    
    class Builder {
        Builder seNode1(Node node1) {
            RTreePickNextAlgo.this.input.node1 = node1;
            return this;
        }

        Builder setNode2(Node node2) {
            RTreePickNextAlgo.this.input.node2 = node2;
            return this;
        }

        Builder setEntry(Node entry) {
            RTreePickNextAlgo.this.input.entry = entry;
            return this;
        }

        RTreePickNextAlgo build() {
           return RTreePickNextAlgo.this;
       } 
    }
    
    Input input = new Input();
    Input getInput() {
        return input;
    }
    void setInput(Input input) {
        this.input = input;
    }
    
    Output output = new Output();
    Output getOutput() {
        return output;
    }
    void setOutput(Output output) {
        this.output = output;
    }

    Builder builder;
    public Builder getBuilder() {
        if(builder == null) {
            builder = new Builder();
        }
        return builder;
    }

    public void execute(RTreeBase rTree) {
        if(rTree.getDebugMode() >= 1) {
            System.out.println("Pick Next Algo Input");
            System.out.println("Node1:");
            rTree.deepPrint(input.node1);
            System.out.println("Node2:");
            rTree.deepPrint(input.node2);
            System.out.println();
        }

        double enlargment1 = input.node1.getEnlargement(input.entry);
        double enlargment2 = input.node2.getEnlargement(input.entry);
        
        if(enlargment2 < enlargment1)
        {
            output.selectedNode = 1;
        }
        if(enlargment1 < enlargment2)
        {
            output.selectedNode = 2;
        }
        if(enlargment1 == enlargment2)
        {
            output.selectedNode = 0;
        }
        
        if(rTree.getDebugMode() >= 1) {
            System.out.println("Pick Next Algo Output");
            System.out.println("SelectedNode:");
            System.out.println(Integer.toString(output.selectedNode));
            System.out.println();
        }
    }
    
    public Output execute(RTreeBase rTree, Node node1, Node node2, Node entry) {
        input.node1 = node1;
        input.node2 = node2;
        input.entry = entry;
        
        execute(rTree);
        
        return output;
    }
}
