/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import spatial.tree.lab.utility.Rankable;

/**
 *
 * @author Lawal 
 */
class RTreePickSeedAlgo {
    class Input {
        Node node;
         Node getNode() {
            return node;
        }
         void setNode(Node node) {
            this.node = node;
        }
    }

    static class Output implements Rankable {
        Node entry1;
        Node getEntry1() {
            return entry1;
        }
        void setEntry1(Node entry1) {
            this.entry1 = entry1;
        }

        Node entry2;
        Node getEntry2() {
            return entry2;
        }
        void setEntry2(Node entry2) {
            this.entry2 = entry2;
        }
        
        List<Double> sortRank = new ArrayList<>();
        public List<Double> getSortRank() {
            return Collections.unmodifiableList(sortRank);
        }
        public void setRank(List<Double> sortRank) {
            this.sortRank = sortRank;
        }
    }
    
    class Builder {
        Builder setNode(Node node) {
            RTreePickSeedAlgo.this.input.node = node;
            return this;
        }

        RTreePickSeedAlgo build() {
           return RTreePickSeedAlgo.this;
        }
    }

    Input input = new Input();
    Input getInput() {
        return input;
    }
    void setInput(Input input) {
        this.input = input;
    }
    
    Output output = new Output();
    Output getOutput() {
        return output;
    }
    void setOutput(Output output) {
        this.output = output;
    }

    Builder builder;
    public Builder getBuilder() {
        if(builder == null) {
            builder = new Builder();
        }
        return builder;
    }

    public void execute(RTreeBase rTree) {
        if(rTree.getDebugMode() >= 1) {
            System.out.println("Pick Seek Algo Input");
            System.out.println("Node:");
            rTree.deepPrint(input.node);
            System.out.println();
        }
        
        List<Rankable> outputs = new ArrayList<>();
                
        for(Node entry1:input.node.getEntries()) {
            for(Node entry2:input.node.getEntries()) {
                if(!entry1.equals(entry2)) {
                    Output outputItem = new Output();
                    outputItem.entry1 = entry1;
                    outputItem.entry2 = entry2;
                    outputItem.sortRank.add(rTree.createIntermediateNode().getBuilder().
                                                                                addEntryTemporary(entry1).
                                                                                addEntryTemporary(entry2).
                                                                                    build().
                                                                                        getArea() - 
                                                    entry1.getArea() - 
                                                    entry2.getArea());
                    outputs.add(outputItem);
                }
            }
        }
        
        Rankable.sortAsending(outputs);
        
        output = (Output)outputs.get(0);

        if(rTree.getDebugMode() >= 1) {
            System.out.println("Pick Seek Algo Output");
            System.out.println("Entry1:");
            rTree.deepPrint(output.entry1);
            System.out.println("Entry2:");
            rTree.deepPrint(output.entry2);
            System.out.println();
        }
    }
}
