/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

import java.util.ArrayList;

/**
 *
 * @author Lawal 
 */
 class RTreeQuadraticSplitNodeAlgo {
    class Input {
        Node node;
        Node getNode() {
            return node;
        }
        void setNode(Node node) {
            this.node = node;
        }
    }
    
    static class Output {
        Node node1;
         void setNode1(Node node1) {
            this.node1 = node1;
        }
         Node getNode1() {
            return node1;
        }

        Node node2;
        Node getNode2() {
            return node2;
        }
         void setNode2(Node node2) {
            this.node2 = node2;
        }
    }
    
    class Builder {
        Builder setNode(Node node) {
            RTreeQuadraticSplitNodeAlgo.this.input.node = node;
            return this;
        }

        RTreeQuadraticSplitNodeAlgo build() {
            return RTreeQuadraticSplitNodeAlgo.this;
        }
    }
    
    Input input = new Input();
    Input getInput() {
        return input;
    }
    void setInput(Input input) {
        this.input = input;
    }
    
    Output output = new Output();
    Output getOutput() {
        return output;
    }
    void setOutput(Output output) {
        this.output = output;
    }

    RTreePickSeedAlgo pickSeedAlgo = new RTreePickSeedAlgo();
    RTreePickSeedAlgo getPickSeedAlgo() {
        return pickSeedAlgo;
    }
    void setPickSeedAlgo(RTreePickSeedAlgo pickSeedAlgo) {
        this.pickSeedAlgo = pickSeedAlgo;
    }

    RTreeDistributeEntryAlgo distributeEntryAlgo = new RTreeDistributeEntryAlgo();
    RTreeDistributeEntryAlgo getDistributeEntryAlgo() {
        return distributeEntryAlgo;
    }
    void setDistributeEntryAlgo(RTreeDistributeEntryAlgo distributeEntryAlgo) {
        this.distributeEntryAlgo = distributeEntryAlgo;
    }

    Builder builder;
    public Builder getBuilder() {
        if(builder == null) {
            builder = new Builder();
        }
        return builder;
    }

    public void execute(RTreeBase rTree) {
        if(rTree.getDebugMode() >= 1) {
            System.out.println("Quadratic Split Node Algo Input");
            System.out.println("Node:");
            rTree.deepPrint(input.node);
            System.out.println();
        }
        
        Node inputNode = input.node;

        pickSeedAlgo.getBuilder().setNode(inputNode).
                            build().
                                execute(rTree);
     
        output.node1 = rTree.createIntermediateNode().getBuilder().
                                                        addEntryTemporary(pickSeedAlgo.getOutput().getEntry1()).
                                                            build();

        output.node2 = rTree.createIntermediateNode().getBuilder().
                                                        addEntryTemporary(pickSeedAlgo.getOutput().getEntry2()).
                                                            build();
        
        inputNode.getBuilder().
                    removeEntry(pickSeedAlgo.getOutput().getEntry1()).
                    removeEntry(pickSeedAlgo.getOutput().getEntry2()).
                        build();

        for (Node entry:new ArrayList<>(inputNode.getEntries())) {
            distributeEntryAlgo.getBuilder().
                                    setNode1(output.node1).
                                    setNode2(output.node2).
                                    setEntry(entry).
                                        build().
                                            execute(rTree);
                    
            inputNode.getBuilder().
                            removeEntry(entry).
                                build();

            if(output.node1.getEntries().size() == inputNode.getMaxEntries() - inputNode.getMinEntries() + 1 ||
               output.node2.getEntries().size() == inputNode.getMaxEntries() - inputNode.getMinEntries() + 1) {
                break;
            }
        }
        
        if(output.node1.getEntries().size() < output.node2.getEntries().size())
        {
            for (Node entry:inputNode.getEntries()) {
                output.node1.getBuilder().addEntryTemporary(entry).build();
            }
        }
        else
        {
            for (Node entry:inputNode.getEntries()) {
                output.node2.getBuilder().addEntryTemporary(entry).build();
            }
        }
        
        inputNode.getBuilder().removeEntries(new ArrayList<>(inputNode.getEntries())).build();

        if(rTree.getDebugMode() >= 1) {
            System.out.println("Quadratic Split Node Algo Output");
            System.out.println("Node1:");
            rTree.deepPrint(output.node1);
            System.out.println("Node2:");
            rTree.deepPrint(output.node2);
            System.out.println();
        }
    }
}