/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

import java.util.Comparator;
import spatial.tree.lab.Interval.Limit;

/**
 *
 * @author Lawal
 */
public class UtilitySortEntries implements Comparator<Node>{
    enum SortEntriesBy {
        LIMIT,
        DISTANCE_BETWEEN_CENTERS
    }

    int sortByDimension;
    int getSortByDimension() {
        return sortByDimension;
    }
    void setSortByDimension(int sortByDimension) {
        this.sortByDimension = sortByDimension;
    }
    
    Limit sortByLimit;
    Limit getSortByLimit() {
        return sortByLimit;
    }
    void setSortByLimit(Limit sortByLimit) {
        this.sortByLimit = sortByLimit;
    }
    
    SortEntriesBy sortEntriesBy;
    SortEntriesBy getSortEntriesBy() {
        return sortEntriesBy;
    }
    void setSortEntriesBy(SortEntriesBy sortEntriesBy) {
        this.sortEntriesBy = sortEntriesBy;
    }

    UtilitySortEntries(int sortByDimension, Limit sortByLimit, SortEntriesBy sortEntriesBy)
    {
        this.sortByDimension = sortByDimension;
        this.sortByLimit = sortByLimit;
        this.sortEntriesBy = sortEntriesBy;
    }
    
    UtilitySortEntries(SortEntriesBy sortEntriesBy)
    {
        this.sortEntriesBy = sortEntriesBy;
    }

    @Override
    public int compare(Node n1, Node n2) {
        switch(sortEntriesBy)
        {
            case LIMIT:
                if(n1.getIntervalLimit(sortByDimension, sortByLimit) == 
                        n2.getIntervalLimit(sortByDimension, sortByLimit)) {
                    return 0;
                } else {
                    return n1.getIntervalLimit(sortByDimension, sortByLimit) < 
                        n2.getIntervalLimit(sortByDimension, sortByLimit) ? -1 : 1;
                }
                
            case DISTANCE_BETWEEN_CENTERS:
                if(n1.getCenterDistance(n1.getParent()) == 
                        n2.getCenterDistance(n2.getParent())) {
                    return 0;
                } else {
                    return n1.getCenterDistance(n1.getParent()) > 
                        n2.getCenterDistance(n2.getParent()) ? -1 : 1;
                }
        }
        
        return 0;
    }
}
