/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.List;

/**
 *
 * @author Lawal
 */
public class XTree extends RTreeBase {    
    int dim;
    int getDim() {
        return dim;
    }
     void setDim(int dim) {
        this.dim = dim;
    }

    int minEntries;
    int getMinEntries() {
        return minEntries;
    }
     void setMinEntries(int minEntries) {
        this.minEntries = minEntries;
    }

    int maxEntries;
     int getMaxEntries() {
        return maxEntries;
    }
     void setMaxEntries(int maxEntries) {
        this.maxEntries = maxEntries;
    }

    int reInsertCount;
    int getReInsertCount() {
        return reInsertCount;
    }
    void setReInsertCount(int reInsertCount) {
        this.reInsertCount = reInsertCount;
    }
    
    double maxOverlap;
    double getMaxOverlap() {
        return maxOverlap;
    }
    void setMaxOverlap(double maxOverlap) {
        this.maxOverlap = maxOverlap;
    }
    
    int fanout;
    int getFanout() {
        return fanout;
    }
    void setFanout(int fanout) {
        this.fanout = fanout;
    }

    XTreeInsertDataAlgo insertDataAlgo = new XTreeInsertDataAlgo();
    XTreeInsertDataAlgo getInsertDataAlgo() {
        return insertDataAlgo;
    }
    void setInsertDataAlgo(XTreeInsertDataAlgo insertDataAlgo) {
        this.insertDataAlgo = insertDataAlgo;
    }

    public XTree(RandomAccessFile file, int dim, int minEntries, int maxEntries, int reInsertCount, double maxOverlap, int fanout) throws IOException {
        this.setFile(file);

        this.dim = dim;
        this.minEntries = minEntries;
        this.maxEntries = maxEntries;
        this.reInsertCount = reInsertCount;
        this.maxOverlap = maxOverlap;
        this.fanout = fanout;
        
        createNewRootNode();
    }

    void MoveVisitedLevelsDown() {
        List<Integer> visitedLevels = insertDataAlgo.
                                        getInsertNodeAlgo().
                                        getOverflowTreatmentAlgo().
                                        getVisitedLevels();
        for(int i = 0; i < visitedLevels.size(); i++) {
            visitedLevels.set(i, visitedLevels.get(i) + 1);
        }
    }
    
    @Override
    void createNewRootNode() {
        Node newRootNode = new Node().getBuilder()
                                .setDim(dim)
                                .setMinEntries(minEntries)
                                .setMaxEntries(maxEntries)
                                .setId("Root")
                                .setDebugMode(debugMode)
                                .setFile(file)
                                .setIsLoaded(true)
                                .build();

        if(rootNode != null) { 
            rootNode.getBuilder().setId(null);
            newRootNode.getBuilder().addEntry(rootNode);
        }
        
        rootNode = newRootNode;
        
        MoveVisitedLevelsDown();
    }

    @Override
    Node createIntermediateNode() {
        return new Node().getBuilder()
                        .setDim(dim)
                        .setMinEntries(minEntries)
                        .setMaxEntries(maxEntries)
                        .setDebugMode(debugMode)
                        .setFile(file)
                        .setIsLoaded(true)
                        .build();
    }

    @Override
    public Node createDataNode() {
        return new Node().getBuilder()
                        .setDim(dim)
                        .setMinEntries(minEntries)
                        .setMaxEntries(maxEntries)
                        .setIsData(true)
                        .setDebugMode(debugMode)
                        .setFile(file)
                        .setIsLoaded(true)
                        .build();
    }

    @Override
    public void InsertData(Node data) {
        insertDataAlgo.getBuilder().
                        setData(data).
                        setReInsertCount(reInsertCount).
                        setMaxOverlap(maxOverlap).
                        setFanout(fanout).
                            build().
                                execute(this);
    }
}

