/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

/**
 *
 * @author Lawal
 */
public class XTreeInsertDataAlgo  {
    class Input {
        Node data;
        Node getData() {
            return data;
        }
        void setData(Node data) {
            this.data = data;
        }
        
        int reInsertCount;
        int getReInsertCount() {
            return reInsertCount;
        }
        void setReInsertCount(int reInsertCount) {
            this.reInsertCount = reInsertCount;
        }
        
        double maxOverlap;
        double getMaxOverlap() {
            return maxOverlap;
        }
        void setMaxOverlap(double maxOverlap) {
            this.maxOverlap = maxOverlap;
        }

        int fanOut;
        int getFanOut() {
            return fanOut;
        }
        void setFanout(int fanOut) {
            this.fanOut = fanOut;
        }
    }
    
    static class Output {
    }
    
    class Builder {
        Builder setData(Node data) {
            XTreeInsertDataAlgo.this.input.data = data;
            return this;
        }

        Builder setReInsertCount(int reInsertCount) {
            XTreeInsertDataAlgo.this.input.reInsertCount = reInsertCount;
            return this;
        }
        
        Builder setMaxOverlap(double maxOverlap) {
            XTreeInsertDataAlgo.this.input.maxOverlap = maxOverlap;
            return this;
        }

        Builder setFanout(int fanout) {
            XTreeInsertDataAlgo.this.input.fanOut = fanout;
            return this;
        }

        XTreeInsertDataAlgo build() {
            return XTreeInsertDataAlgo.this;
        }
    }

    Input input = new Input();
    Input getInput() {
        return input;
    }
    void setInput(Input input) {
        this.input = input;
    }
    
    Output output = new Output();
    Output getOutput() {
        return output;
    }
    void setOutput(Output output) {
        this.output = output;
    }
    
    XTreeInsertNodeAlgo insertNodeAlgo = new XTreeInsertNodeAlgo();
    XTreeInsertNodeAlgo getInsertNodeAlgo() {
        return insertNodeAlgo;
    }
    void setInsertNodeAlgo(XTreeInsertNodeAlgo insertNodeAlgoBase) {
        this.insertNodeAlgo = insertNodeAlgoBase;
    }

    Builder builder;
    public Builder getBuilder() {
        if(builder == null) {
            builder = new Builder();
        }
        return builder;
    }

    void execute(RTreeBase rTree) {
        if(rTree.getDebugMode() >= 1) {
            System.out.println("Insert Data Algo Input");
            System.out.println("Data:");
            rTree.deepPrint(input.data);
            System.out.println("ReInsertCount:");
            System.out.println(input.reInsertCount);
            System.out.println("MaxOverlap:");
            System.out.println(input.maxOverlap);
            System.out.println("FanOut:");
            System.out.println(input.fanOut);
            System.out.println();
        }

        insertNodeAlgo.getOverflowTreatmentAlgo().getVisitedLevels().clear();
        
        insertNodeAlgo.getBuilder().
                        setNode(input.data).
                        setLevel(rTree.getLeafNodeLevel()).
                        setReInsertCount(input.reInsertCount).
                        setMaxOverlap(input.maxOverlap).
                        setFanout(input.fanOut).
                            build().
                                execute(rTree);
    }
}

