/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

/**
 *
 * @author Lawal
 */
public class XTreeInsertNodeAlgo {
    class Input {
        Node node;
        Node getNode() {
            return node;
        }
        void setData(Node node) {
            this.node = node;
        }
    
        int level;
        int getLevel() {
            return level;
        }
        void setLevel(int level) {
            this.level = level;
        }

        int reInsertCount;
        int getReInsertCount() {
            return reInsertCount;
        }
        void setReInsertCount(int reInsertCount) {
            this.reInsertCount = reInsertCount;
        }
        
        double maxOverlap;
        double getMaxOverlap() {
            return maxOverlap;
        }
        void setMaxOverlap(double maxOverlap) {
            this.maxOverlap = maxOverlap;
        }

        int fanOut;
        int getFanOut() {
            return fanOut;
        }
        void setFanOut(int fanOut) {
            this.fanOut = fanOut;
        }
    }
    
    static class Output {
    }
    
    class Builder {
        Builder setNode(Node node) {
            XTreeInsertNodeAlgo.this.input.node = node;
            return this;
        }

        Builder setLevel(int level) {
            XTreeInsertNodeAlgo.this.input.level = level;
            return this;
        }

        Builder setReInsertCount(int reInsertCount) {
            XTreeInsertNodeAlgo.this.input.reInsertCount = reInsertCount;
            return this;
        }
        
        Builder setMaxOverlap(double maxOverlap) {
            XTreeInsertNodeAlgo.this.input.maxOverlap = maxOverlap;
            return this;
        }

        Builder setFanout(int fanout) {
            XTreeInsertNodeAlgo.this.input.fanOut = fanout;
            return this;
        }

        XTreeInsertNodeAlgo build() {
            return XTreeInsertNodeAlgo.this;
        }
    }
    
    Input input = new Input();
    Input getInput() {
        return input;
    }
    void setInput(Input input) {
        this.input = input;
    }
    
    Output output = new Output();
    Output getOutput() {
        return output;
    }
    void setOutput(Output output) {
        this.output = output;
    }

    RAsteriskChooseSubTreeAlgo chooseSubTreeAlgo = new RAsteriskChooseSubTreeAlgo();
    RAsteriskChooseSubTreeAlgo getChooseSubTreeAlgo() {
        return chooseSubTreeAlgo;
    }
    void setChooseSubTreeAlgo(RAsteriskChooseSubTreeAlgo chooseSubTreeAlgo) {
        this.chooseSubTreeAlgo = chooseSubTreeAlgo;
    }
    
    XTreeSplitNodeAlgo splitNodeAlgo = new XTreeSplitNodeAlgo();
    XTreeSplitNodeAlgo getSplitNodeAlgo() {
        return splitNodeAlgo;
    }
    void setSplitNodeAlgo(XTreeSplitNodeAlgo splitNodeAlgoBase) {
        this.splitNodeAlgo = splitNodeAlgoBase;
    }

    XTreeOverflowTreatmentAlgo overflowTreatmentAlgo = new XTreeOverflowTreatmentAlgo(this);
    XTreeOverflowTreatmentAlgo getOverflowTreatmentAlgo() {
        return overflowTreatmentAlgo;
    }
    void setOverflowTreatmentAlgo(XTreeOverflowTreatmentAlgo overflowTreatmentAlgo) {
        this.overflowTreatmentAlgo = overflowTreatmentAlgo;
    }

    XTreeInsertNodeAlgo() {
        overflowTreatmentAlgo.getReInsertNodeAlgo().setInsertNodeAlgo(this);
    }
    
    Builder builder;
    public Builder getBuilder() {
        if(builder == null) {
            builder = new Builder();
        }
        return builder;
    }

    void execute(RTreeBase rTree) {
        if(rTree.getDebugMode() >= 1) {
            System.out.println("Insert Node Algo Input");
            System.out.println("Node:");
            rTree.deepPrint(input.node);
            System.out.println("Level:");
            System.out.println(input.level);
            System.out.println("ReInsertCount:");
            System.out.println(input.reInsertCount);
            System.out.println("MaxOverlap:");
            System.out.println(input.maxOverlap);
            System.out.println("FanOut:");
            System.out.println(input.fanOut);
            System.out.println();
        }

        chooseSubTreeAlgo.getBuilder().
                            setEntry(input.node).
                            setNode(rTree.rootNode).
                            setLevel(input.level).
                                build().
                                    execute(rTree);
                
        chooseSubTreeAlgo.getOutput().getNode().getBuilder().addEntry(input.node);
        
        if(!chooseSubTreeAlgo.getOutput().getNode().isIsSuperNode()) {
            if(chooseSubTreeAlgo.getOutput().getNode().ExceedMaxEntries()) {
                    overflowTreatmentAlgo.getBuilder().
                            setNode(chooseSubTreeAlgo.getOutput().getNode()).
                            setLevel(input.level).
                            setReInsertCount(input.reInsertCount).
                            setMaxOverlap(input.maxOverlap).
                            setFanout(input.fanOut).
                                build().
                                    execute(rTree);
            }
        }
    }
}

