/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

/**
 *
 * @author Lawal
 */
public class XTreeReInsertNodeAlgo {
    class Input {
        Node node;
        Node getNode() {
            return node;
        }
        void setData(Node node) {
            this.node = node;
        }
        
        int reInsertCount;
        int getReInsertCount() {
            return reInsertCount;
        }
        void setReInsertCount(int reInsertCount) {
            this.reInsertCount = reInsertCount;
        }
    }
    
    static class Output {
    }

    class Builder {
        Builder setNode(Node node) {
            XTreeReInsertNodeAlgo.this.input.node = node;
            return this;
        }
        
        Builder setReInsertCount(int reInsertCount) {
            XTreeReInsertNodeAlgo.this.input.reInsertCount = reInsertCount;
            return this;
        }

        XTreeReInsertNodeAlgo build() {
            return XTreeReInsertNodeAlgo.this;
        }
    }
    
    Input input = new Input();
    Input getInput() {
        return input;
    }
    void setInput(Input input) {
        this.input = input;
    }
    
    Output output = new Output();
    Output getOutput() {
        return output;
    }
    void setOutput(Output output) {
        this.output = output;
    }

    XTreeInsertNodeAlgo insertNodeAlgo;
    XTreeInsertNodeAlgo getInsertNodeAlgo() {
        return insertNodeAlgo;
    }
    void setInsertNodeAlgo(XTreeInsertNodeAlgo insertNodeAlgo) {
        this.insertNodeAlgo = insertNodeAlgo;
    }
    
    Builder builder;
    public Builder getBuilder() {
        if(builder == null) {
            builder = new Builder();
        }
        return builder;
    }

    void execute(RTreeBase rTree) {
        if(rTree.getDebugMode() >= 1) {
            System.out.println("ReInsert Node Algo Input");
            System.out.println("Node:");
            rTree.deepPrint(input.node);
            System.out.println("ReInsertCount:");
            System.out.println(input.reInsertCount);
            System.out.println();
        }

        Node node = rTree.createIntermediateNode();
        node.getBuilder().addEntriesTemporary(input.node.getEntries());

        node.getEntries().sort(new UtilitySortEntries(UtilitySortEntries.SortEntriesBy.DISTANCE_BETWEEN_CENTERS));
        
        for(int i = 0; i < input.getReInsertCount(); i++) {
            Node entry = node.getEntry(i);
            input.node.getBuilder().removeEntry(entry);
        }

        for(int i = 0; i < input.getReInsertCount(); i++) {
            Node entry = node.getEntry(i);
            
            insertNodeAlgo.getBuilder().
                            setNode(entry).
                            setLevel(entry.getLevel() - 1).
                                build().
                                    execute(rTree);
        }
    }
}
