/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

/**
 *
 * @author Lawal
 */
class XTreeSplitNodeAlgo {
    class Input {
        Node node;
        Node getNode() {
            return node;
        }
        void setData(Node node) {
            this.node = node;
        }
    
        int reInsertCount;
        int getReInsertCount() {
            return reInsertCount;
        }
        void setReInsertCount(int reInsertCount) {
            this.reInsertCount = reInsertCount;
        }
        
        double maxOverlap;
        double getMaxOverlap() {
            return maxOverlap;
        }
        void setMaxOverlap(double maxOverlap) {
            this.maxOverlap = maxOverlap;
        }

        int fanOut;
        int getFanOut() {
            return fanOut;
        }
        void setFanOut(int fanOut) {
            this.fanOut = fanOut;
        }
    }
    
    static class Output {
        Node node1;
         void setNode1(Node node1) {
            this.node1 = node1;
        }
         Node getNode1() {
            return node1;
        }

        Node node2;
         Node getNode2() {
            return node2;
        }
         void setNode2(Node node2) {
            this.node2 = node2;
        }

        boolean succeded;
        boolean isSucceded() {
            return succeded;
        }
        void setSucceded(boolean succeded) {
            this.succeded = succeded;
        }
    }
    
    class Builder {
        Builder setNode(Node node) {
            XTreeSplitNodeAlgo.this.input.node = node;
            return this;
        }

        Builder setReInsertCount(int reInsertCount) {
            XTreeSplitNodeAlgo.this.input.reInsertCount = reInsertCount;
            return this;
        }
        
        Builder setMaxOverlap(double maxOverlap) {
            XTreeSplitNodeAlgo.this.input.maxOverlap = maxOverlap;
            return this;
        }

        Builder setFanout(int fanout) {
            XTreeSplitNodeAlgo.this.input.fanOut = fanout;
            return this;
        }

        XTreeSplitNodeAlgo build() {
            return XTreeSplitNodeAlgo.this;
        }
    }
    
    Input input = new Input();
    Input getInput() {
        return input;
    }
    void setInput(Input input) {
        this.input = input;
    }
    
    Output output = new Output();
    Output getOutput() {
        return output;
    }
    void setOutput(Output output) {
        this.output = output;
    }
    
    RAsteriskChooseSplitAxisAlgo chooseSplitAxisAlgo = new RAsteriskChooseSplitAxisAlgo();
    RAsteriskChooseSplitAxisAlgo getChooseSplitAxisAlgo() {
        return chooseSplitAxisAlgo;
    }
    void setChooseSplitAxisAlgo(RAsteriskChooseSplitAxisAlgo chooseSplitAxisAlgo) {
        this.chooseSplitAxisAlgo = chooseSplitAxisAlgo;
    }
    
    RAsteriskChooseSplitIndexAlgo chooseSplitIndexAlgo = new RAsteriskChooseSplitIndexAlgo();
    RAsteriskChooseSplitIndexAlgo getChooseSplitIndexAlgo() {
        return chooseSplitIndexAlgo;
    }
    void setChooseSplitIndexAlgo(RAsteriskChooseSplitIndexAlgo chooseSplitIndexAlgo) {
        this.chooseSplitIndexAlgo = chooseSplitIndexAlgo;
    }

    Builder builder;
    public Builder getBuilder() {
        if(builder == null) {
            builder = new Builder();
        }
        return builder;
    }

    void execute(RTreeBase rTree) {
        if(rTree.getDebugMode() >= 1) {
            System.out.println("Split Node Algo Input");
            System.out.println("Node:");
            rTree.deepPrint(input.node);
            System.out.println("ReInsertCount:");
            System.out.println(input.reInsertCount);
            System.out.println("MaxOverlap:");
            System.out.println(input.maxOverlap);
            System.out.println("FanOut:");
            System.out.println(input.fanOut);
            System.out.println();
        }

        chooseSplitAxisAlgo.getBuilder().
                            setNode(input.node).
                                build().
                                    execute(rTree);
        
        chooseSplitIndexAlgo.getBuilder().
                                setNode(input.node).
                                setAxis(chooseSplitAxisAlgo.getOutput().getAxis()).
                                    build().
                                        execute(rTree);
        
        output.node1 = chooseSplitIndexAlgo.getOutput().getNode1();
        output.node2 = chooseSplitIndexAlgo.getOutput().getNode2();
        
        output.succeded = false;
        
        if(output.node1.getOverlapPercent(output.node2) < input.maxOverlap) {
            output.succeded = true;
            input.node.splittedByDim(chooseSplitAxisAlgo.getOutput().getAxis());
        }
        else {
            for(int i = 0; i < input.node.getDim(); i++) {
                boolean splittedBy = false;
                for(Node entry:input.node.getEntries()) {
                    splittedBy = splittedBy & entry.getSplitDimHistory().get(i);
                }
                
                if(splittedBy) {
                    output.node1.getBuilder().removeEntries(output.node1.getEntries());
                    output.node1.getBuilder().addEntriesTemporary(input.node.getEntries().subList(0, input.node.getEntriesCount() % 2 - 1));
                    
                    output.node2.getBuilder().removeEntries(output.node2.getEntries());
                    output.node2.getBuilder().addEntriesTemporary(input.node.getEntries().subList(input.node.getEntriesCount() % 2, input.node.getEntriesCount() - 1));
                    
                    output.succeded = true;
                    
                    break;
                }
            }

            if(!output.succeded) {
                if(input.node.isRoot()) {
                    output.succeded  = true;
                } 
                else {
                    if(!(output.node1.getEntriesCount() < input.fanOut ||
                         output.node2.getEntriesCount() < input.fanOut)) {
                        output.succeded  = true;
                    }
                }
            }
        }
        
        if(rTree.getDebugMode() >= 1) {
            System.out.println("Split Node Algo Output");
            System.out.println("Node1:");
            rTree.deepPrint(output.node1);
            System.out.println("Node2:");
            rTree.deepPrint(output.node2);
            System.out.println("Succeded:");
            System.out.println(output.succeded);
        }
    }
}
