/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab.adapters;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import spatial.tree.lab.Node;
import spatial.tree.lab.RTreeBase;

/**
 *
 * @author Mahmoud
 */
public class TextFileAdapter {
    String fileName;
    public String getFileName() {
        return fileName;
    }
    public void setFileName(String fileName) {
        this.fileName = fileName;
    }
    
    File file;
    BufferedReader fileReader;
    public void start(RTreeBase rTree) throws FileNotFoundException, IOException {
        file = new File(fileName); 
        fileReader = new BufferedReader(new FileReader(file)); 
    }
    
    public void end() throws FileNotFoundException, IOException {
        fileReader.close();
    }

    public Node getNext(RTreeBase rTree) throws FileNotFoundException, IOException {
        String st = fileReader.readLine();
        if(st == null) return null;
        
        Node leaf = rTree.createDataNode();
        
        String[] items = st.split("\t");

        leaf.getBuilder().setId(items[0]);

        for(int i = 1; i < items.length; i++) {
            items[i] = items[i].trim();
            
            boolean firstNegative = false;
            if(items[i].startsWith("-")) {
                items[i] = items[i].substring(1);
                firstNegative = true;
            }
            
            boolean secondNegative = false;
            if(items[i].contains("--")) {
                items[i] = items[i].replace("--", "-");
                secondNegative = true;
            }

            String[] rangs = items[i].split("-");
            
            if(rangs.length == 1) {
                
                try
                {
                
                leaf.getBuilder().setInterval(i - 1, firstNegative ? -Double.parseDouble(rangs[0]) : Double.parseDouble(rangs[0]));
                }
                catch(Exception e)
                {
                    int jj = 0;
                }
            }
            else {
                leaf.getBuilder().setInterval(i - 1, 
                                                firstNegative ? -Double.parseDouble(rangs[0]) : Double.parseDouble(rangs[0]), 
                                                secondNegative ? -Double.parseDouble(rangs[1]) : Double.parseDouble(rangs[1]));
            }
        }
        
        return leaf;
    }
}
