/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab.experiment;

import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.List;
import java.util.Scanner;
import spatial.tree.lab.MinBoundingRectangle;
import spatial.tree.lab.RTree;
import spatial.tree.lab.query.RandomUniformConstrainRangeQueryGenerator;
import spatial.tree.lab.utility.FileUtility;

/**
 *
 * @author Mahmoud
 */
public class RandomConstrainQueryCreation {
    public static void main(String[] args) throws IOException, InterruptedException {
        System.out.println("********** Generate Random Contrain Query **************\n");        
        Scanner sc = new Scanner(System.in);

        System.out.println("Enter number of dimensions: ");
        int d = sc.nextInt();
        
        System.out.println("Enter M: ");
        int M = sc.nextInt();
        
        System.out.println("Enter m: ");
        int m = sc.nextInt();

        System.out.println("Enter number of queries: ");
        int numberOfQueries = sc.nextInt();

        System.out.println("Select dimension to be queried: ");
        int qd = sc.nextInt();
        
        System.out.println("Select constrain percentage of inteval query: ");
        double qp = sc.nextDouble();

        System.out.println("Enter file name: ");
        String f = sc.next();

        FileUtility fileUtility = new FileUtility();
        RandomAccessFile treeFile = fileUtility.openRandomAccessFile(f);

        RTree rtree = new RTree(treeFile, d, m, M);
        rtree.setDebugMode(0);
        rtree.getRootNode().setSequence(0);
        rtree.getRootNode().setIsLoaded(false);
        rtree.getRootNode().loadNode();
        
        RandomUniformConstrainRangeQueryGenerator q = new RandomUniformConstrainRangeQueryGenerator();
        List<MinBoundingRectangle> r = q.generateRandomQueries(rtree.getRootNode().getMinBoundingRectangle(), 
                                                                qd, numberOfQueries, qp);
        
        for(int i = 0; i < r.size(); i++) {
            System.out.print(Integer.toString(i + 1) + "\t");
            
            if(r.get(i).getIntervalA(0) == r.get(i).getIntervalB(0)) {
                System.out.print(Double.toString(r.get(i).getIntervalA(0)));
            }
            else {
                System.out.print(Double.toString(r.get(i).getIntervalA(0)));
                System.out.print("-");
                System.out.print(Double.toString(r.get(i).getIntervalB(0)));
            }
            
            System.out.print("\n");
        }
    }
    
}
