/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab.experiment;

import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.List;
import java.util.Scanner;
import spatial.tree.lab.MinBoundingRectangle;
import spatial.tree.lab.RTree;
import spatial.tree.lab.query.RandomUniformSelectivityQueryGenerator;
import spatial.tree.lab.utility.FileUtility;

/**
 *
 * @author Mahmoud
 */
public class RandomQueryCreation {
    public static void main(String[] args) throws IOException, InterruptedException {
        System.out.println("********** Generate Random Query **************\n");        
        Scanner sc = new Scanner(System.in);

        System.out.println("Enter number of dimensions: ");
        int d = sc.nextInt();
        
        System.out.println("Enter M: ");
        int M = sc.nextInt();
        
        System.out.println("Enter m: ");
        int m = sc.nextInt();

        System.out.println("Enter number of queries: ");
        int numberOfQueries = sc.nextInt();

        System.out.println("Enter selected leave count: ");
        int SelectedLeaveCount = sc.nextInt();

        System.out.println("Enter file name: ");
        String f = sc.next();

        FileUtility fileUtility = new FileUtility();
        RandomAccessFile treeFile = fileUtility.openRandomAccessFile(f);

        RTree rtree = new RTree(treeFile, d, m, M);
        rtree.setDebugMode(0);
        rtree.getRootNode().setSequence(0);
        rtree.getRootNode().setIsLoaded(false);
        rtree.getRootNode().loadNode();        
        
        RandomUniformSelectivityQueryGenerator q = new RandomUniformSelectivityQueryGenerator();
        List<MinBoundingRectangle> r = q.generateRandomQueries(rtree, numberOfQueries, SelectedLeaveCount);
        
        for(int i = 0; i < r.size(); i++) {
            System.out.print(Integer.toString(i + 1) + "\t");
            
            for(int j = 0; j < d; j++) {
                
                if(r.get(i).getIntervalA(j) == r.get(i).getIntervalB(j)) {
                    System.out.print(Double.toString(r.get(i).getIntervalA(j)));
                }
                else {
                    System.out.print(Double.toString(r.get(i).getIntervalA(j)));
                    System.out.print("-");
                    System.out.print(Double.toString(r.get(i).getIntervalB(j)));
                }
                
                System.out.print("\t");
            }
            System.out.print("\n");
        }
    }
}
