/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab.query;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import spatial.tree.lab.MinBoundingRectangle;
import spatial.tree.lab.RQueryResult;
import spatial.tree.lab.RTreeBase;

/**
 *
 * @author Mahmoud
 */
public class RandomUniformConstrainRangeQueryGenerator {
    public List<MinBoundingRectangle> generateRandomQueries(MinBoundingRectangle rootMbr, int d, int numberOfQueries, double intervalPercent) {
        List<MinBoundingRectangle> queriesMbr = new ArrayList<>();
        
        Random rand = new Random(1);
        
        for(int q = 0; q < numberOfQueries; q++) {
            MinBoundingRectangle query = new MinBoundingRectangle(1);
            double intervalLength = rootMbr.getIntervalB(d) - rootMbr.getIntervalA(d);
            double rangeLength = intervalPercent / 100 * (intervalLength);
                    
            double a = rootMbr.getIntervalA(d) + (intervalLength - rangeLength) * rand.nextDouble();
            double b = a + rangeLength;

            query.getBuilder().setInterval(0, a, b);
            
            queriesMbr.add(query);
        }
        
        return queriesMbr;
    }    
}
