/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab.query;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.Scanner;
import spatial.tree.lab.MinBoundingRectangle;


/**
 *
 * @author Mahmoud
 */
public class RandomUniformQueryGenerator {
    public List<MinBoundingRectangle> generateRandomQueries(MinBoundingRectangle rootMbr, int numberOfQueries, double IntervalPercentFrom, double IntervalPercentTo) {
        List<MinBoundingRectangle> queriesMbr = new ArrayList<>();
        
        Random rand = new Random(1);
        
        for(int q = 0; q < numberOfQueries; q++) {
            MinBoundingRectangle query = new MinBoundingRectangle(rootMbr.getDim());
            
            for(int d = 0; d < rootMbr.getDim(); d++) {
                double intervalLength = rootMbr.getIntervalB(d) - rootMbr.getIntervalA(d);
                double center = rootMbr.getIntervalA(d) + intervalLength * rand.nextDouble();
                double length = (IntervalPercentTo - IntervalPercentFrom) / 100 * intervalLength * rand.nextDouble();

                double a = center - length / 2;
                double b = a + length / 2;
                
                query.getBuilder().setInterval(d, a, b);
                
                
            }
            
            queriesMbr.add(query);
        }
        
        return queriesMbr;
    }
    
    
    /**
     *
     * @param args
     */
    public static void main(String[] args) {
        System.out.println("********** Random Query **************");
        
        Scanner sc = new Scanner(System.in);

        // Input the tree
        System.out.println("Enter rtree file name: ");
        String fileName = sc.nextLine();
        
        // Read header
        int m = 3;
        int M = 5;
        int dim = 2;
        
        MinBoundingRectangle rootMbr = new MinBoundingRectangle(dim);
        
        // Input query data
        System.out.println("Enter number of random queries to be generated along dimension: ");
        int numberOfQueries = sc.nextInt();
        
        System.out.println("Enter minimum ratio of query dimension length to root dimension length: ");
        double xyRatioStart = sc.nextDouble();

        System.out.println("Enter maximum ratio of query dimension length to root dimension length: ");
        double xyRatioEnd = sc.nextDouble();
        
        sc.close();
        
        
        List<MinBoundingRectangle> queriesMbr = new ArrayList<>(numberOfQueries);
        
        Random rand = new Random(1);
        for(int q = 0; q < numberOfQueries; q++) {
            MinBoundingRectangle query = queriesMbr.get(q);
            query.getBuilder().setDim(dim).build();
            
            for(int d = 0; d < dim; d++) {
                query.getBuilder().setInterval(d, rootMbr.getIntervalA(d) * rand.nextDouble());
                query.getBuilder().setInterval(d, query.getIntervalA(d) + (xyRatioEnd - xyRatioStart) * rand.nextDouble());
            }
            
            
        }
    }
}
