/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab.query;

import java.io.RandomAccessFile;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.Scanner;
import spatial.tree.lab.MinBoundingRectangle;
import spatial.tree.lab.RQueryResult;
import spatial.tree.lab.RTreeBase;

/**
 *
 * @author Mahmoud
 */
public class RandomUniformSelectivityQueryGenerator {
    public List<MinBoundingRectangle> generateRandomQueries(RTreeBase rTree, int numberOfQueries, int SelectedLeaveCount) {
        List<MinBoundingRectangle> queriesMbr = new ArrayList<>();
        
        Random rand = new Random(1);
        
        MinBoundingRectangle rootMbr = rTree.getRootNode().getMinBoundingRectangle();
        
        for(int q = 0; q < numberOfQueries; q++) {
            MinBoundingRectangle query = new MinBoundingRectangle(rootMbr.getDim());
            
            for(int d = 0; d < rootMbr.getDim(); d++) {
                double intervalLength = rootMbr.getIntervalB(d) - rootMbr.getIntervalA(d);
                double center = rootMbr.getIntervalA(d) + intervalLength * rand.nextDouble();

                double a = center;
                double b = center;

                query.getBuilder().setInterval(d, a, b);
            }
            
            double value = 0;
            double inc = 10;
            
            boolean reachToBest = false;
            
            while(!reachToBest) {
                value = value + inc;
                
                for(int d = 0; d < rootMbr.getDim(); d++) {
                    double intervalLength = rootMbr.getIntervalB(d) - rootMbr.getIntervalA(d);
                    double length = value / 100 * intervalLength;

                    double center = (query.getIntervalA(d) + query.getIntervalB(d)) / 2;
                    
                    double a = center - length / 2;
                    double b = center + length / 2;

                    query.getBuilder().setInterval(d, a, b);
                }
                
                RQueryResult rQueryResult = rTree.getNodes(query);
                
                if(inc > 0 && rQueryResult.getLeaves().size() > SelectedLeaveCount) {
                    inc = -inc / 10;
                }

                if(inc < 0 && rQueryResult.getLeaves().size() < SelectedLeaveCount) {
                    inc = -inc / 10;
                }
                
                if(Math.abs((double)rQueryResult.getLeaves().size() - (double)SelectedLeaveCount) / (double)SelectedLeaveCount < .01 ||
                   Math.abs(inc) < .0001) {
                    reachToBest = true;
                }
            }
            
            queriesMbr.add(query);
        }
        
        return queriesMbr;
    }    
}
