/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab.testing;

import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.ArrayList;
import java.util.List;
import spatial.tree.lab.MinBoundingRectangle;
import spatial.tree.lab.Node;
import spatial.tree.lab.RQueryResult;
import spatial.tree.lab.RTree;
import spatial.tree.lab.XTree;
import spatial.tree.lab.adapters.TextFileAdapter;
import spatial.tree.lab.dataset.SnytheticDataSetGenerator;
import spatial.tree.lab.utility.ByteBufferUtility;
import spatial.tree.lab.utility.FileUtility;

/**
 *
 * @author Mahmoud
 */
public class TestLargeData {

    /**
    *
    * @param args
    */
    public static void main(String[] args) throws IOException, InterruptedException{
        System.out.println("********** TestRTreeTextFile Million **************\n");
        
        FileUtility fileUtility = new FileUtility();
        //RandomAccessFile file = fileUtility.openRandomAccessFile("c:\\temp1\\treeLargeData.txt");
        
        long counter = 900000;
        
        int dim = 5;
        int m = 2;
        int M = 10;
        //RTree rtree = new RTree(file, dim, m, M);
        //rtree.setDebugMode(0);
        RandomAccessFile file = fileUtility.openRandomAccessFile("c:\\temp1\\treeLargeData" + counter + ".txt");
        RTree rtree = new RTree(file, dim, m, M);
        rtree.getRootNode().setSequence(0);
        rtree.getRootNode().setIsLoaded(false);
        rtree.getRootNode().loadNode();
                
        SnytheticDataSetGenerator generator = new SnytheticDataSetGenerator();
        generator.createDataSet("c:\\temp1\\LargeDataSet.txt", 5,  100 * 1000, 20.0, 'E');

        TextFileAdapter textFileAdapter = new TextFileAdapter();
        textFileAdapter.setFileName("c:\\temp1\\LargeDataSet.txt");
        
        textFileAdapter.start(rtree);
        
        List<Node> dataLeaves = new  ArrayList<>();
        
        Node leaf = textFileAdapter.getNext(rtree);
        dataLeaves.add(leaf);
        while(leaf != null) {
            rtree.InsertData(leaf);
            leaf = textFileAdapter.getNext(rtree);
            
            counter++;

            if(counter % 100000 == 0 && counter > 0) {
                if(leaf != null) dataLeaves.add(leaf);
                System.out.println(counter);
                
                System.out.println("********** Save the Tree **************\n");
                //fileUtility.saveToFile(rtree, "c:\\temp1\\treeLargeData" + counter + ".txt");
                file.close();
                
                file = fileUtility.openRandomAccessFile("c:\\temp1\\treeLargeData" + counter + ".txt");
                rtree = new RTree(file, dim, m, M);
                rtree.getRootNode().setSequence(0);
                rtree.getRootNode().setIsLoaded(false);
                rtree.getRootNode().loadNode();
            }
            
        }
        
        textFileAdapter.end();
        
        System.out.println("********** Tree Output **************\n");
        
        System.out.println("Number of Levels:" + Integer.toString(rtree.getLeafLevel()));
        //System.out.println("Nonleaf Nodes Count:" + Integer.toString(rtree.getNodeCount()));
        System.out.println("Leaves Count:" + Integer.toString(rtree.getLeafCount()));
        System.out.println("Single Node Memory Size:" + Integer.toString(rtree.getMaxNodeMemorySize()));
        System.out.println("Memory Page Size:" + Integer.toString(ByteBufferUtility.MEMORY_PAGE_SIZE));
        System.out.println("Memory Size:" + Long.toString(rtree.getMemorySize()));
        System.out.println("Hard Drive Size:" + Long.toString(rtree.getHardDriveSize()));
        System.out.println();
        
        file.close();
        
        System.out.println("********** Execute Random Query **************\n");
        for(int i = 0; i < dataLeaves.size(); i++) {
            System.out.println(i + "- " + dataLeaves.get(i).toFullString());
            
            file = fileUtility.openRandomAccessFile("c:\\temp1\\treeLargeData" + counter + ".txt");
            
            RTree rtreeToQuery = new RTree(file,dim, m, M);
            rtreeToQuery.getRootNode().setSequence(0);
            rtreeToQuery.getRootNode().setIsLoaded(false);
            rtreeToQuery.getRootNode().loadNode();
            
            
            MinBoundingRectangle rqueryMbr = dataLeaves.get(i).getMinBoundingRectangle();
            RQueryResult rQueryResult = rtreeToQuery.getNodes(rqueryMbr);
            rQueryResult.markNodesAsSelected();
            
            int pages = 0;
            for(Node node:rQueryResult.getVisitedNodes()) {
                pages += node.getPagesCount();
            }
            
            System.out.println("Number of Pages Visited:" + Integer.toString(pages));
            System.out.println("Number of Nodes Visited:" + Integer.toString(rQueryResult.getVisitedNodes().size()));
            System.out.println("Number of Data Leafs:" + Integer.toString(rQueryResult.getLeaves().size()));
            System.out.println("Execution Time in Nano Second:" + Long.toString(rQueryResult.getExecutionTime()));
            
            rtreeToQuery.printSelected();
                        
            rQueryResult.unmarkNodesAsSelected();
            
            file.close();
        }
    }
}
