package spatial.tree.lab.testing;


import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.List;
import spatial.tree.lab.utility.ByteBufferUtility;
import spatial.tree.lab.utility.FileUtility;
import spatial.tree.lab.MinBoundingRectangle;
import spatial.tree.lab.Node;
import spatial.tree.lab.RQueryResult;
import spatial.tree.lab.RTree;
import spatial.tree.lab.query.RandomUniformQueryGenerator;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author Lawal
 */
public class TestRTreeRQuery {

    /**
     *
     * @param args
     */
    public static void main(String[] args) throws IOException{
        System.out.println("**********  Query  *********");

        MinBoundingRectangle minBoundingRectangle = new MinBoundingRectangle(5).getBuilder().
                                                                setInterval(0, 65, 140.0).
                                                                setInterval(1, 25, 89.0).
                                                                setInterval(2, 2, 5).
                                                                setInterval(3, 54, 87).
                                                                setInterval(4, 34, 56).
                                                                    build();
        System.out.println(minBoundingRectangle.toFullString());
        System.out.println();
        
        FileUtility fileUtility = new FileUtility();
        RandomAccessFile file = fileUtility.openRandomAccessFile("d:\\file1.txt");
        RTree rtree = new RTree(null, 5, 2, 5);
        RQueryResult rQueryResult = rtree.getNodes(minBoundingRectangle);
        
        
        int pages = 0;
        for(Node node:rQueryResult.getVisitedNodes()) {
            pages += node.getPagesCount();
        }
        System.out.println("Number of Pages Visited:" + Integer.toString(pages));
        System.out.println("Number of Nodes Visited:" + Integer.toString(rQueryResult.getVisitedNodes().size()));
        
        for(Node node:rQueryResult.getVisitedNodes()) {
            System.out.println(node.toFullString(node.getLevel()));
        }

        System.out.println("**********  Data *********");
        System.out.println();
        System.out.println("Number of Data Leafs:" + Integer.toString(rQueryResult.getLeaves().size()));
        System.out.println();
        
        for(Node data:rQueryResult.getLeaves()) {
            System.out.println(data.getParent().toFullString(data.getParent().getLevel()));
            System.out.println(data.toFullString(data.getLevel()));
        }
        
        System.out.println();
        System.out.println("**********  Query Response Time *********");
        System.out.println();
        
        System.out.println("Execution Time in Nano Second:" + Long.toString(rQueryResult.getExecutionTime()));
        
        fileUtility.closeRandomAccessFile(file);
    }
}
