/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab.utility;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.RandomAccessFile;
import java.util.ArrayList;
import java.util.List;
import spatial.tree.lab.RTreeBase;
import spatial.tree.lab.dataset.SnytheticDataSetGenerator;

/**
 *
 * @author Lawal
 */
public class FileUtility {
    public static final int FILE_SECTOR_SIZE = 512;

    public void saveToFile(RTreeBase rTree) throws IOException {
        rTree.prepareToSave();

        rTree.getFile().seek(0);
        rTree.writeToByteArray(rTree.getFile());
    }

    public RandomAccessFile openRandomAccessFile(String fileName) throws FileNotFoundException {
        return new RandomAccessFile(fileName, "rw");
    }
    
    public byte[] getBytesFromRandomAccessFile(RandomAccessFile file, long poistion, int size) throws IOException {
        file.seek(poistion);
        byte[] bytes = new byte[size];
        file.read(bytes);
        return bytes;
    }
    
    public byte[] getBytesFromRandomAccessFile(String fileName, long poistion, int size) throws IOException {
        RandomAccessFile file = new RandomAccessFile(fileName, "rw");
        file.seek(poistion);
        byte[] bytes = new byte[size];
        file.read(bytes);
        file.close();
        return bytes;
    }
    
    public void closeRandomAccessFile(RandomAccessFile file) throws FileNotFoundException, IOException {
        file.close();
    }
    
    public static void main(String[] args) throws IOException, InterruptedException{
        System.out.println("********** TestRTreeTextFile1000 **************\n");
        SnytheticDataSetGenerator generator = new SnytheticDataSetGenerator();
        generator.createDataSet("d:\\Tree10Million.txt", 5, 10000000, 20.0, 'E');
        
    }
}
