/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spatial.tree.lab;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.RandomAccessFile;
import static org.junit.Assert.assertEquals;
import static org.testng.Assert.*;
import org.testng.annotations.AfterClass;
import org.testng.annotations.AfterMethod;
import org.testng.annotations.BeforeClass;
import org.testng.annotations.BeforeMethod;
import org.testng.annotations.Test;
import spatial.tree.lab.utility.FileUtility;

/**
 *
 * @author Mahmoud
 */
public class RTreePickSeedAlgoNGTest {
    
    public RTreePickSeedAlgoNGTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @BeforeMethod
    public void setUpMethod() throws Exception {
    }

    @AfterMethod
    public void tearDownMethod() throws Exception {
    }

    /**
     * Test of execute method, of class RTreePickSeedAlgo.
     */
    @Test
    public void testExecute() throws FileNotFoundException, IOException {
        System.out.println("execute");
        
        FileUtility fileUtility = new FileUtility();
        RandomAccessFile treeFile = fileUtility.openRandomAccessFile("C:\\PhD\\Results\\PickSeed.rTree");
        
        RTree rTree = new RTree(treeFile, 2, 2, 3);
        
        Node node = rTree.createIntermediateNode();
        
        Node entry1 = rTree.createDataNode().getBuilder().
                                setId("A").
                                setInterval(0, 1, 2).
                                setInterval(1, 3, 5).
                                build();
        
        node.getBuilder().addEntry(entry1);
        
        Node entry2 = rTree.createDataNode().getBuilder().
                                setId("B").
                                setInterval(0, 2, 6).
                                setInterval(1, 1, 4).
                                build();
        
        node.getBuilder().addEntry(entry2);

        Node entry3 = rTree.createDataNode().getBuilder().
                                setId("C").
                                setInterval(0, 2, 12).
                                setInterval(1, 5, 14).
                                build();
        
        node.getBuilder().addEntry(entry3);

        Node entry4 = rTree.createDataNode().getBuilder().
                                setId("D").
                                setInterval(0, 11, 22).
                                setInterval(1, 4, 14).
                                build();
        
        node.getBuilder().addEntry(entry4);
        
        RTreePickSeedAlgo instance = new RTreePickSeedAlgo();
        instance.getInput().setNode(node);
        instance.execute(rTree);
        assertEquals(instance.getOutput().getEntry1().getId(), "B");
        assertEquals(instance.getOutput().getEntry2().getId(), "D");
    }
}
